<template>
  <el-dialog title="Edit call" :visible.sync="dialogVisible" @close="cancelForm()">
    <el-form :model="call">
      <el-form-item label="Made at" prop="madeAt">
        <el-date-picker v-model="call.madeAt" type="datetime" style="width: 100%"></el-date-picker>
      </el-form-item>

      <el-form-item label="Agent" prop="agentId">
        <el-select v-model="call.agentId" style="width: 100%">
          <el-option v-for="agent in this.$data.agents" :key="agent.id" :label="agent.username" :value="agent.id"></el-option>
        </el-select>
      </el-form-item>
    </el-form>

    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button @click="deleteCall()" type="danger">Delete</el-button>
      <el-button type="primary" @click="submitForm()">Save</el-button>
    </span>
  </el-dialog>
</template>

<script>
import gql from 'graphql-tag'
import CallEditQuery from '../../graphql/queries/call_edit'

export default {
  apollo: {
    call: {
      query: CallEditQuery,
      variables() { return { id: this.$route.params.id } },
      update({ call }) {
        let madeAt = call.madeAt ? new Date(call.madeAt.substr(0, 10) + "T" + call.madeAt.substr(11, 8)) : null
        return { id: call.id, madeAt: madeAt, agentId: call.agentId }}
    },
    agents: {
      query: gql`{ users(role: "agent"){ id username profile { firstName lastName } } }`,
      update({ users }) { return  users }
    }
  },

  data() {
    return {
      dialogVisible: true,
      agents: [],
      call: { id: null, madeAt: null, agentId: null }
    }
  },

  mounted () {
    this.$apollo.queries.call.refetch()
  },

  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($call: CallInput!) {
          updateCall(call: $call) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { call: this.$data.call },
        update: (store, { data: { updateCall } }) => {
          if(updateCall.success) {
            this.$message.success('Call updated successfully')
            this.$data.dialogVisible = false
            this.$router.push(`/calls/${this.$route.params.id}`)    
          }
          else
            this.$message.error('Failed to update call')
        }
      })
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push(`/calls/${this.$route.params.id}`)
    },
    deleteCall() {
      this.$confirm('Are you sure you want to delete this call?', {
          confirmButtonText: 'OK',
          cancelButtonText: 'Cancel',
          type: 'warning'
        }).then(() => {
          this.$apollo.mutate({
            mutation: gql`mutation ($call: CallInput!) {
              deleteCall(call: $call) {
                success message errors { field message }
              }
            }`,
            variables: { call: { id: this.$route.params.id } },
            update: (store, { data: { deleteCall } }) => {
              if(deleteCall.success) {
                this.$message.success('Call deleted successfully')
                this.$data.dialogVisible = false
                this.$router.push('/calls')
              }
              else
                this.$message.error('Failed to delete call')
            }
          })
        })
    }
  }
}
</script>
